// Quick and Dirty instruction test harness

// cl -Ox imul.c

#include <windows.h>

#include <stdio.h>
#include <stdlib.h>

DWORD emptytest(void)
{
  DWORD ticks;

  _asm
  {
    rdtsc
    push eax

    mov ecx,1000

    mov eax,1

loop_empty:

    dec ecx
    jnz loop_empty

    rdtsc
    pop ecx
    sub eax,ecx
    mov ticks,eax
  }

  return(ticks);
}

DWORD imultest(void)
{
  DWORD ticks;

  _asm
  {
    rdtsc
    push eax

    mov ecx,1000

    mov eax,1

loop_mul:

    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1

    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1

    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1
    imul eax,1

    dec ecx
    jnz loop_mul

    rdtsc
    pop ecx
    sub eax,ecx
    mov ticks,eax
  }

  return(ticks);
}

DWORD idivtest(void)
{
  DWORD ticks;

  _asm
  {
    rdtsc
    push eax

    mov ecx,1000

    mov eax,1
    xor edx,edx

loop_div:

    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax

    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax

    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax
    idiv eax

    dec ecx
    jnz loop_div

    rdtsc
    pop ecx
    sub eax,ecx
    mov ticks,eax
  }

  return(ticks);
}
DWORD shifttest(void)
{
  DWORD ticks;

  _asm
  {
    rdtsc
    push eax

    mov ecx,1000

    mov eax,1

loop_shift:

    shl eax,1
    shr eax,1
    shl eax,1
    shr eax,1
    shl eax,1
    shr eax,1
    shl eax,1
    shr eax,1
    shl eax,1
    shr eax,1

    shl eax,1
    shr eax,1
    shl eax,1
    shr eax,1
    shl eax,1
    shr eax,1
    shl eax,1
    shr eax,1
    shl eax,1
    shr eax,1

    shl eax,1
    shr eax,1
    shl eax,1
    shr eax,1
    shl eax,1
    shr eax,1
    shl eax,1
    shr eax,1
    shl eax,1
    shr eax,1

    dec ecx
    jnz loop_shift

    rdtsc
    pop ecx
    sub eax,ecx
    mov ticks,eax
  }

  return(ticks);
}

DWORD shift8test(void)
{
  DWORD ticks;

  _asm
  {
    rdtsc
    push eax

    mov ecx,1000

    mov eax,1

loop_shift8:

    shl eax,8
    shr eax,8
    shl eax,8
    shr eax,8
    shl eax,8
    shr eax,8
    shl eax,8
    shr eax,8
    shl eax,8
    shr eax,8

    shl eax,8
    shr eax,8
    shl eax,8
    shr eax,8
    shl eax,8
    shr eax,8
    shl eax,8
    shr eax,8
    shl eax,8
    shr eax,8

    shl eax,8
    shr eax,8
    shl eax,8
    shr eax,8
    shl eax,8
    shr eax,8
    shl eax,8
    shr eax,8
    shl eax,8
    shr eax,8

    dec ecx
    jnz loop_shift8

    rdtsc
    pop ecx
    sub eax,ecx
    mov ticks,eax
  }

  return(ticks);
}

DWORD xchgtest(void)
{
  DWORD ticks;

  _asm
  {
    rdtsc
    push eax

    mov ecx,1000

    mov eax,1

loop_xchg:

    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]

    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]

    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]
    xchg eax,[ticks]

    dec ecx
    jnz loop_xchg

    rdtsc
    pop ecx
    sub eax,ecx
    mov ticks,eax
  }

  return(ticks);
}

int main(int argc, char **argv)
{
  int i;
  DWORD empty;
  DWORD ticks, minticks;

#define LOOPS 1000

  puts("Empty");

  minticks = 0xFFFFFFFFF;

  for(i=0; i<LOOPS; i++)
  {
    ticks = emptytest();
    if (LOOPS <= 10)
      printf("%6d Ticks\n", ticks);
    minticks = min(minticks, ticks);
  }

  printf("%10d Ticks (min), %6.3lf cycles\n", minticks, (double)minticks / 30000.0);

  putchar('\n');

  empty = minticks;

  puts("IMUL eax, 1");

  minticks = 0xFFFFFFFFF;

  for(i=0; i<LOOPS; i++)
  {
    ticks = imultest() - empty;
    if (LOOPS <= 10)
      printf("%6d Ticks\n", ticks);
    minticks = min(minticks, ticks);
  }

  printf("%10d Ticks (min), %6.3lf cycles\n", minticks, (double)minticks / 30000.0);

  putchar('\n');

  puts("IDIV eax, 1");

  minticks = 0xFFFFFFFFF;

  for(i=0; i<LOOPS; i++)
  {
    ticks = idivtest() - empty;
    if (LOOPS <= 10)
      printf("%6d Ticks\n", ticks);
    minticks = min(minticks, ticks);
  }

  printf("%10d Ticks (min), %6.3lf cycles\n", minticks, (double)minticks / 30000.0);

  putchar('\n');

  puts("SHL eax, 1 / SHR eax, 1");

  minticks = 0xFFFFFFFFF;

  for(i=0; i<LOOPS; i++)
  {
    ticks = shifttest() - empty;
    if (LOOPS <= 10)
      printf("%6d Ticks\n", ticks);
    minticks = min(minticks, ticks);
  }

  printf("%10d Ticks (min), %6.3lf cycles\n", minticks, (double)minticks / 30000.0);

  putchar('\n');

  puts("SHL eax, 8 / SHR eax, 8");

  minticks = 0xFFFFFFFFF;

  for(i=0; i<LOOPS; i++)
  {
    ticks = shift8test() - empty;
    if (LOOPS <= 10)
      printf("%6d Ticks\n", ticks);
    minticks = min(minticks, ticks);
  }

  printf("%10d Ticks (min), %6.3lf cycles\n", minticks, (double)minticks / 30000.0);

  putchar('\n');

  puts("XCHG eax, [mem]");

  minticks = 0xFFFFFFFFF;

  for(i=0; i<LOOPS; i++)
  {
    ticks = xchgtest() - empty;
    if (LOOPS <= 10)
      printf("%6d Ticks\n", ticks);
    minticks = min(minticks, ticks);
  }

  printf("%10d Ticks (min), %6.3lf cycles\n", minticks, (double)minticks / 30000.0);

  putchar('\n');

  puts("Press any key to continue...");
  getch();
}

